Index: applications/editors/josm/plugins/seachart/src/s57/S57map.java
===================================================================
--- applications/editors/josm/plugins/seachart/src/s57/S57map.java	(revision 31738)
+++ applications/editors/josm/plugins/seachart/src/s57/S57map.java	(revision 31846)
@@ -153,15 +153,19 @@
 		public boolean forward;	// Direction of vector used (LINEs & AREAs)
 		public boolean outer;		// Exterior/Interior boundary (AREAs)
+		public boolean trunc;		// Cell limit truncation
 		public Prim() {
-			id = 0; forward = true; outer = true;
+			id = 0; forward = true; outer = true; trunc = false;
 		}
 		public Prim(long i) {
-			id = i; forward = true; outer = true;
+			id = i; forward = true; outer = true; trunc = false;
 		}
 		public Prim(long i, boolean o) {
-			id = i; forward = true; outer = o;
+			id = i; forward = true; outer = o; trunc = false;
 		}
 		public Prim(long i, boolean f, boolean o) {
-			id = i; forward = f; outer = o;
+			id = i; forward = f; outer = o; trunc = false;
+		}
+		public Prim(long i, boolean f, boolean o, boolean t) {
+			id = i; forward = f; outer = o; trunc = t;
 		}
 	}
@@ -191,7 +195,7 @@
 		public Geom(Pflag p) {
 			prim = p;
-			elems = new ArrayList<Prim>();
+			elems = new ArrayList<>();
 			outers = inners = 0;
-			comps = new ArrayList<Comp>();
+			comps = new ArrayList<>();
 			area = 0;
 			length = 0;
@@ -548,213 +552,10 @@
 	}
 	
-	enum Ext {I, N, W, S, E }
-	
 	public void mapDone() {
-		class Land {
-			long first;
-			Snode start;
-			Ext sbound;
-			long last;
-			Snode end;
-			Ext ebound;
-			Feature land;
-			Land (Feature l) {
-				land = l;
-				first = last = 0;
-				start = end = null;
-				sbound = ebound = Ext.I;
-			}
-		}
-		if (features.get(Obj.COALNE) != null) {
-			ArrayList<Feature> coasts = new ArrayList<Feature>();
-			ArrayList<Land> lands = new ArrayList<Land>();
-			if (features.get(Obj.LNDARE) == null) {
-				features.put(Obj.LNDARE, new ArrayList<Feature>());
-			}
-			for (Feature feature : features.get(Obj.COALNE)) {
-				Feature land = new Feature();
-				land.id = ++xref;
-				land.type = Obj.LNDARE;
-				land.reln = Rflag.MASTER;
-				land.objs.put(Obj.LNDARE, new ObjTab());
-				land.objs.get(Obj.LNDARE).put(0, new AttMap());
-				if (feature.geom.prim == Pflag.AREA) {
-					land.geom = feature.geom;
-					features.get(Obj.LNDARE).add(land);
-				} else if (feature.geom.prim == Pflag.LINE) {
-					land.geom.prim = Pflag.LINE;
-					land.geom.elems.addAll(feature.geom.elems);
-					coasts.add(land);
-				}
-			}
-			while (coasts.size() > 0) {
-				Feature land = coasts.remove(0);
-				Edge fedge = edges.get(land.geom.elems.get(0).id);
-				long first = fedge.first;
-				long last = edges.get(land.geom.elems.get(land.geom.elems.size() - 1).id).last;
-				if (coasts.size() > 0) {
-					boolean added = true;
-					while (added) {
-						added = false;
-						for (int i = 0; i < coasts.size(); i++) {
-							Feature coast = coasts.get(i);
-							Edge edge = edges.get(coast.geom.elems.get(0).id);
-							if (edge.first == last) {
-								land.geom.elems.add(coast.geom.elems.get(0));
-								last = edge.last;
-								coasts.remove(i--);
-								added = true;
-							} else if (edge.last == first) {
-								land.geom.elems.add(0, coast.geom.elems.get(0));
-								first = edge.first;
-								coasts.remove(i--);
-								added = true;
-							}
-						}
-					}
-				}
-				lands.add(new Land(land));
-			}
-			ArrayList<Land> islands = new ArrayList<Land>();
-			for (Land land : lands) {
-				sortGeom(land.land);
-				if (land.land.geom.prim == Pflag.AREA) {
-					islands.add(land);
-					features.get(Obj.LNDARE).add(land.land);
-				}
-			}
-			for (Land island : islands) {
-				lands.remove(island);
-			}
-			for (Land land : lands) {
-				GeomIterator git = new GeomIterator(land.land.geom);
-				Snode prev = null;
-				Ext bprev = Ext.I;
-				Ext ext;
-				land.ebound = land.sbound = Ext.I;
-				while (git.hasComp()) {
-					git.nextComp();
-					while (git.hasEdge()) {
-						git.nextEdge();
-						while (git.hasNode()) {
-							long ref = git.nextRef(false);
-							Snode node = nodes.get(ref);
-							if (node == null) continue;
-							if (land.first == 0) {
-								land.first = ref;
-							}
-							if (prev == null) {
-								prev = node;
-							}
-							if ((node.lat >= bounds.maxlat) && (node.lon < bounds.maxlon)) {
-								ext = Ext.N;
-							} else if (node.lon <= bounds.minlon) {
-								ext = Ext.W;
-							} else if (node.lat <= bounds.minlat) {
-								ext = Ext.S;
-							} else if (node.lon >= bounds.maxlon) {
-								ext = Ext.E;
-							} else {
-								ext = Ext.I;
-							}
-							if (ext == Ext.I) {
-								if (land.start == null) {
-									land.start = prev;
-									land.sbound = bprev;
-								}
-								land.end = null;
-								land.ebound = Ext.I;
-							} else {
-								if ((land.start != null) && (land.end == null)) {
-									land.end = node;
-									land.ebound = ext;
-								}
-							}
-							prev = node;
-							bprev = ext;
-							land.last = ref;
-						}
-					}
-				}
-			}
-			islands = new ArrayList<Land>();
-			for (Land land : lands) {
-				if ((land.sbound == Ext.I) || (land.ebound == Ext.I)) {
-					islands.add(land);
-				}
-			}
-			for (Land island : islands) {
-				lands.remove(island);
-			}
-			while (lands.size() > 0) {
-				Land land = lands.get(0);
-				Edge nedge = new Edge();
-				nedge.first = land.last;
-				Ext bound = land.ebound;
-				Snode last = land.end;
-				double delta = Math.PI;
-				int idx = -1;
-				Land next = null;
-				while (idx < 0) {
-					for (int i = 0; i < lands.size(); i++) {
-						next = lands.get(i);
-						if (next.sbound == bound) {
-							double diff = -Math.PI;
-							switch (bound) {
-							case N:
-								diff = last.lon - next.start.lon;
-								break;
-							case W:
-								diff = last.lat - next.start.lat;
-								break;
-							case S:
-								diff = next.start.lon - last.lon;
-								break;
-							case E:
-								diff = next.start.lat - last.lat;
-								break;
-							default:
-								continue;
-							}
-							if ((diff >= 0.0) && (diff < delta)) {
-								delta = diff;
-								idx = i;
-							}
-						}
-					}
-					if (idx < 0) {
-						long ref = (long)bound.ordinal();
-						last = nodes.get(ref);
-						nedge.nodes.add(ref);
-						ref = ref < 4 ? ++ref : 1;
-						for (Ext e : Ext.values()) {
-							if (ref == e.ordinal()) {
-								bound = e;
-								break;
-							}
-						}
-					}
-				}
-				next = lands.get(idx);
-				nedge.last = next.first;
-				edges.put(++xref, nedge);
-				land.land.geom.elems.add(new Prim(xref));
-				if (next != land) {
-					land.land.geom.elems.addAll(next.land.geom.elems);
-					land.ebound = next.ebound;
-					land.end = next.end;
-					land.last = next.last;
-					lands.remove(idx);
-				}
-				sortGeom(land.land);
-				if (land.land.geom.prim == Pflag.AREA) {
-					features.get(Obj.LNDARE).add(land.land);
-					lands.remove(land);
-				}
-			}
-		}
-		return;
-	}
-
+		if (!sea) {
+			S57box.bBox(this);
+		}
+	}
+	
 	// Utility methods
 	
@@ -836,5 +637,5 @@
 				if (ie == 0) feature.geom.area = Math.abs(area) * 3444 * 3444;
 				if (((ie == 0) && (area < 0.0)) || ((ie > 0) && (area >= 0.0))) {
-					ArrayList<Prim> tmp = new ArrayList<Prim>();
+					ArrayList<Prim> tmp = new ArrayList<>();
 					for (int i = 0; i < feature.geom.comps.get(ic).size; i++) {
 						Prim p = feature.geom.elems.remove(ie);
Index: applications/editors/josm/plugins/seachart/src/s57/S57obj.java
===================================================================
--- applications/editors/josm/plugins/seachart/src/s57/S57obj.java	(revision 31738)
+++ applications/editors/josm/plugins/seachart/src/s57/S57obj.java	(revision 31846)
@@ -29,5 +29,5 @@
 	}
 
-	private static final EnumMap<Obj, Integer> ObjS57 = new EnumMap<Obj, Integer>(Obj.class);
+	private static final EnumMap<Obj, Integer> ObjS57 = new EnumMap<>(Obj.class);
 	static {
 		ObjS57.put(Obj.UNKOBJ,0);
@@ -66,5 +66,5 @@
 	}
 
-	private static final EnumMap<Obj, Integer> ObjIENC = new EnumMap<Obj, Integer>(Obj.class);
+	private static final EnumMap<Obj, Integer> ObjIENC = new EnumMap<>(Obj.class);
 	static {
 		ObjIENC.put(Obj.UNKOBJ, 0);
@@ -81,5 +81,5 @@
 	}
 
-	private static final EnumMap<Obj, String> ObjStr = new EnumMap<Obj, String>(Obj.class);
+	private static final EnumMap<Obj, String> ObjStr = new EnumMap<>(Obj.class);
 	static {
 		ObjStr.put(Obj.UNKOBJ, "");	ObjStr.put(Obj.AIRARE, "airfield");	ObjStr.put(Obj.ACHBRT, "anchor_berth"); ObjStr.put(Obj.ACHARE, "anchorage");
@@ -130,5 +130,5 @@
 	}
 	
-	private static final HashMap<String, Obj> StrObj = new HashMap<String, Obj>();
+	private static final HashMap<String, Obj> StrObj = new HashMap<>();
 	static {
 		for (Map.Entry<Obj, String> entry : ObjStr.entrySet()) {
Index: applications/editors/josm/plugins/seachart/src/s57/S57osm.java
===================================================================
--- applications/editors/josm/plugins/seachart/src/s57/S57osm.java	(revision 31738)
+++ applications/editors/josm/plugins/seachart/src/s57/S57osm.java	(revision 31846)
@@ -11,8 +11,6 @@
 
 import java.io.BufferedReader;
-import java.io.IOException;
 import java.util.*;
 
-import s57.S57map.Feature;
 import s57.S57obj.*;
 import s57.S57att.*;
@@ -21,54 +19,4 @@
 public class S57osm { // OSM to S57 Object/Attribute and Object/Primitive conversions
 	
-	enum Prims { N, P, L, A, PA, PL, LA, PLA }
-	private static final EnumMap<Obj, Prims> S57prims = new EnumMap<Obj, Prims>(Obj.class);
-	static {
-		S57prims.put(Obj.UNKOBJ, Prims.PLA); S57prims.put(Obj.M_COVR, Prims.A); S57prims.put(Obj.M_NSYS, Prims.A); S57prims.put(Obj.AIRARE, Prims.PA);
-		S57prims.put(Obj.ACHBRT, Prims.PA); S57prims.put(Obj.ACHARE, Prims.PA); S57prims.put(Obj.BCNCAR, Prims.P); S57prims.put(Obj.BCNISD, Prims.P);
-		S57prims.put(Obj.BCNLAT, Prims.P); S57prims.put(Obj.BCNSAW, Prims.P); S57prims.put(Obj.BCNSPP, Prims.P); S57prims.put(Obj.BERTHS, Prims.PLA);
-		S57prims.put(Obj.BRIDGE, Prims.PLA); S57prims.put(Obj.BUISGL, Prims.PA); S57prims.put(Obj.BUAARE, Prims.PA); S57prims.put(Obj.BOYCAR, Prims.P);
-		S57prims.put(Obj.BOYINB, Prims.P); S57prims.put(Obj.BOYISD, Prims.P); S57prims.put(Obj.BOYLAT, Prims.P); S57prims.put(Obj.BOYSAW, Prims.P);
-		S57prims.put(Obj.BOYSPP, Prims.P); S57prims.put(Obj.CBLARE, Prims.A); S57prims.put(Obj.CBLOHD, Prims.L); S57prims.put(Obj.CBLSUB, Prims.L);
-		S57prims.put(Obj.CANALS, Prims.A); S57prims.put(Obj.CTSARE, Prims.PA); S57prims.put(Obj.CAUSWY, Prims.LA); S57prims.put(Obj.CTNARE, Prims.PA);
-		S57prims.put(Obj.CHKPNT, Prims.PA); S57prims.put(Obj.CGUSTA, Prims.P); S57prims.put(Obj.COALNE, Prims.L); S57prims.put(Obj.CONZNE, Prims.A);
-		S57prims.put(Obj.COSARE, Prims.A); S57prims.put(Obj.CTRPNT, Prims.P); S57prims.put(Obj.CONVYR, Prims.LA); S57prims.put(Obj.CRANES, Prims.PA);
-		S57prims.put(Obj.CURENT, Prims.P); S57prims.put(Obj.CUSZNE, Prims.A); S57prims.put(Obj.DAMCON, Prims.LA); S57prims.put(Obj.DAYMAR, Prims.P);
-		S57prims.put(Obj.DWRTCL, Prims.L); S57prims.put(Obj.DWRTPT, Prims.A); S57prims.put(Obj.DEPARE, Prims.A); S57prims.put(Obj.DEPCNT, Prims.L);
-		S57prims.put(Obj.DISMAR, Prims.P); S57prims.put(Obj.DOCARE, Prims.A); S57prims.put(Obj.DRGARE, Prims.A); S57prims.put(Obj.DRYDOC, Prims.A);
-		S57prims.put(Obj.DMPGRD, Prims.PA); S57prims.put(Obj.DYKCON, Prims.L); S57prims.put(Obj.EXEZNE, Prims.A); S57prims.put(Obj.FAIRWY, Prims.A);
-		S57prims.put(Obj.FNCLNE, Prims.L); S57prims.put(Obj.FERYRT, Prims.LA); S57prims.put(Obj.FSHZNE, Prims.A); S57prims.put(Obj.FSHFAC, Prims.PLA);
-		S57prims.put(Obj.FSHGRD, Prims.A); S57prims.put(Obj.FLODOC, Prims.A); S57prims.put(Obj.FOGSIG, Prims.P); S57prims.put(Obj.FORSTC, Prims.PLA);
-		S57prims.put(Obj.FRPARE, Prims.A); S57prims.put(Obj.GATCON, Prims.PLA); S57prims.put(Obj.GRIDRN, Prims.PA); S57prims.put(Obj.HRBARE, Prims.A);
-		S57prims.put(Obj.HRBFAC, Prims.PA); S57prims.put(Obj.HULKES, Prims.PA); S57prims.put(Obj.ICEARE, Prims.A); S57prims.put(Obj.ICNARE, Prims.PA);
-		S57prims.put(Obj.ISTZNE, Prims.A); S57prims.put(Obj.LAKARE, Prims.A); S57prims.put(Obj.LNDARE, Prims.PLA); S57prims.put(Obj.LNDELV, Prims.PL);
-		S57prims.put(Obj.LNDRGN, Prims.PA); S57prims.put(Obj.LNDMRK, Prims.PLA); S57prims.put(Obj.LIGHTS, Prims.P); S57prims.put(Obj.LITFLT, Prims.P);
-		S57prims.put(Obj.LITVES, Prims.P); S57prims.put(Obj.LOCMAG, Prims.PLA); S57prims.put(Obj.LOKBSN, Prims.A); S57prims.put(Obj.LOGPON, Prims.PA);
-		S57prims.put(Obj.MAGVAR, Prims.PLA); S57prims.put(Obj.MARCUL, Prims.PLA); S57prims.put(Obj.MIPARE, Prims.PA); S57prims.put(Obj.MORFAC, Prims.PLA);
-		S57prims.put(Obj.MPAARE, Prims.PA); S57prims.put(Obj.NAVLNE, Prims.L); S57prims.put(Obj.OBSTRN, Prims.PLA); S57prims.put(Obj.OFSPLF, Prims.PA);
-		S57prims.put(Obj.OSPARE, Prims.A); S57prims.put(Obj.OILBAR, Prims.L); S57prims.put(Obj.PILPNT, Prims.P); S57prims.put(Obj.PILBOP, Prims.PA);
-		S57prims.put(Obj.PIPARE, Prims.PA); S57prims.put(Obj.PIPOHD, Prims.L); S57prims.put(Obj.PIPSOL, Prims.PL); S57prims.put(Obj.PONTON, Prims.LA);
-		S57prims.put(Obj.PRCARE, Prims.PA); S57prims.put(Obj.PRDARE, Prims.PA); S57prims.put(Obj.PYLONS, Prims.PA); S57prims.put(Obj.RADLNE, Prims.L);
-		S57prims.put(Obj.RADRNG, Prims.A); S57prims.put(Obj.RADRFL, Prims.P); S57prims.put(Obj.RADSTA, Prims.P); S57prims.put(Obj.RTPBCN, Prims.P);
-		S57prims.put(Obj.RDOCAL, Prims.PL); S57prims.put(Obj.RDOSTA, Prims.P); S57prims.put(Obj.RAILWY, Prims.L); S57prims.put(Obj.RAPIDS, Prims.PLA);
-		S57prims.put(Obj.RCRTCL, Prims.L); S57prims.put(Obj.RECTRC, Prims.LA); S57prims.put(Obj.RCTLPT, Prims.PA); S57prims.put(Obj.RSCSTA, Prims.P);
-		S57prims.put(Obj.RESARE, Prims.A); S57prims.put(Obj.RETRFL, Prims.P); S57prims.put(Obj.RIVERS, Prims.LA); S57prims.put(Obj.ROADWY, Prims.PLA);
-		S57prims.put(Obj.RUNWAY, Prims.PLA); S57prims.put(Obj.SNDWAV, Prims.PLA); S57prims.put(Obj.SEAARE, Prims.PA); S57prims.put(Obj.SPLARE, Prims.PA);
-		S57prims.put(Obj.SBDARE, Prims.PLA); S57prims.put(Obj.SLCONS, Prims.PLA); S57prims.put(Obj.SISTAT, Prims.P); S57prims.put(Obj.SISTAW, Prims.P);
-		S57prims.put(Obj.SILTNK, Prims.PA); S57prims.put(Obj.SLOTOP, Prims.L); S57prims.put(Obj.SLOGRD, Prims.PA); S57prims.put(Obj.SMCFAC, Prims.PA);
-		S57prims.put(Obj.SOUNDG, Prims.P); S57prims.put(Obj.SPRING, Prims.P); S57prims.put(Obj.STSLNE, Prims.L); S57prims.put(Obj.SUBTLN, Prims.A);
-		S57prims.put(Obj.SWPARE, Prims.A); S57prims.put(Obj.TESARE, Prims.A); S57prims.put(Obj.TS_PRH, Prims.PA); S57prims.put(Obj.TS_PNH, Prims.PA);
-		S57prims.put(Obj.TS_PAD, Prims.PA); S57prims.put(Obj.TS_TIS, Prims.PA); S57prims.put(Obj.T_HMON, Prims.PA); S57prims.put(Obj.T_NHMN, Prims.PA);
-		S57prims.put(Obj.T_TIMS, Prims.PA); S57prims.put(Obj.TIDEWY, Prims.LA); S57prims.put(Obj.TOPMAR, Prims.P); S57prims.put(Obj.TSELNE, Prims.LA);
-		S57prims.put(Obj.TSSBND, Prims.L); S57prims.put(Obj.TSSCRS, Prims.A); S57prims.put(Obj.TSSLPT, Prims.A); S57prims.put(Obj.TSSRON, Prims.A);
-		S57prims.put(Obj.TSEZNE, Prims.A); S57prims.put(Obj.TUNNEL, Prims.LA); S57prims.put(Obj.TWRTPT, Prims.A); S57prims.put(Obj.UWTROC, Prims.P);
-		S57prims.put(Obj.UNSARE, Prims.A); S57prims.put(Obj.VEGATN, Prims.PLA); S57prims.put(Obj.WATTUR, Prims.PLA); S57prims.put(Obj.WATFAL, Prims.PL);
-		S57prims.put(Obj.WEDKLP, Prims.PA); S57prims.put(Obj.WRECKS, Prims.PA); S57prims.put(Obj.TS_FEB, Prims.PA);
-		S57prims.put(Obj.NOTMRK, Prims.P); S57prims.put(Obj.WTWAXS, Prims.L); S57prims.put(Obj.WTWPRF, Prims.L); S57prims.put(Obj.BUNSTA, Prims.PA);
-		S57prims.put(Obj.COMARE, Prims.A); S57prims.put(Obj.HRBBSN, Prims.A); S57prims.put(Obj.LKBSPT, Prims.A); S57prims.put(Obj.PRTARE, Prims.A);
-		S57prims.put(Obj.REFDMP, Prims.P); S57prims.put(Obj.TERMNL, Prims.PA); S57prims.put(Obj.TRNBSN, Prims.PA); S57prims.put(Obj.WTWARE, Prims.A);
-		S57prims.put(Obj.WTWGAG, Prims.PA); S57prims.put(Obj.TISDGE, Prims.N); S57prims.put(Obj.VEHTRF, Prims.PA); S57prims.put(Obj.EXCNST, Prims.PA);
-		S57prims.put(Obj.LG_SDM, Prims.A); S57prims.put(Obj.LG_VSP, Prims.A);
-	}
-
 	static class KeyVal<V> {
 		Obj obj;
@@ -84,5 +32,5 @@
 	}
 	
-	private static final HashMap<String, KeyVal<?>> OSMtags = new HashMap<String, KeyVal<?>>();
+	private static final HashMap<String, KeyVal<?>> OSMtags = new HashMap<>();
 	static {
 		OSMtags.put("natural=coastline", new KeyVal<>(Obj.COALNE, Att.UNKATT, null, null)); OSMtags.put("natural=water", new KeyVal<>(Obj.LAKARE, Att.UNKATT, null, null));
@@ -114,5 +62,5 @@
 	}
 	
-	public static void OSMmap(BufferedReader in, S57map map) throws IOException {
+	public static void OSMmap(BufferedReader in, S57map map) throws Exception {
 		String k = "";
 		String v = "";
@@ -271,17 +219,3 @@
 	}
 	
-	public static void OSMgeom(Feature feature, S57map map) {
-		switch (S57prims.get(feature.type)) {
-		case N:
-		case P:
-		case L:
-		case A:
-		case PA:
-		case PL:
-		case LA:
-		case PLA:
-		}
-	}
-
-
 }
